// @flow
import _ from 'lodash';
import {combineReducers} from 'redux';
import rest from './rest';
import type {TSourceItem} from './typedefs/source-item';

export default (sources: Array<TSourceItem>) => combineReducers(_.reduce(sources, (reducers, source) => ({
	...reducers,

	[source.key]: (state={data: [], loading: false}, action) => {
		let

			/* eslint-disable sort-vars */
			restSource = rest(source),
			newState = restSource.reducers[source.key](state, action);

		if(_.isArray(source.reducers))
			newState = _.reduce(source.reducers, (resultState, reducer) => reducer(resultState, action), newState);

		/* eslint-enable sort-vars */
		if(action.type === restSource.events[source.key].actionSuccess)
			return {
				...newState,
				lastResponse: action.origData,
			};

		return newState;
	},
}), {}));
